// Borland C++ Builder
// Copyright (c) 1995, 2002 by Borland Software Corporation
// All rights reserved

// (DO NOT EDIT: machine generated header) 'DBLists.pas' rev: 6.00

#ifndef DBListsHPP
#define DBListsHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <BDE.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <BdeUtils.hpp>	// Pascal unit
#include <DBUtils.hpp>	// Pascal unit
#include <DBTables.hpp>	// Pascal unit
#include <DB.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Dblists
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TBDEItemType { bdDatabases, bdDrivers, bdLangDrivers, bdUsers, bdRepositories };
#pragma option pop

class DELPHICLASS TCustomBDEItems;
class PASCALIMPLEMENTATION TCustomBDEItems : public Dbtables::TBDEDataSet 
{
	typedef Dbtables::TBDEDataSet inherited;
	
private:
	TBDEItemType FItemType;
	AnsiString FSessionName;
	Dbtables::TDatabase* FSessionLink;
	Dbtables::TSession* __fastcall GetDBSession(void);
	void __fastcall SetSessionName(const AnsiString Value);
	void __fastcall SetItemType(TBDEItemType Value);
	
protected:
	virtual int __fastcall GetRecordCount(void);
	virtual void __fastcall OpenCursor(bool InfoQuery);
	virtual void __fastcall CloseCursor(void);
	virtual Bde::hDBICur __fastcall CreateHandle(void);
	__property TBDEItemType ItemType = {read=FItemType, write=SetItemType, default=0};
	
public:
	virtual bool __fastcall Locate(const AnsiString KeyFields, const Variant &KeyValues, Db::TLocateOptions Options);
	__property Dbtables::TSession* DBSession = {read=GetDBSession};
	
__published:
	__property AnsiString SessionName = {read=FSessionName, write=SetSessionName};
public:
	#pragma option push -w-inl
	/* TBDEDataSet.Create */ inline __fastcall virtual TCustomBDEItems(Classes::TComponent* AOwner) : Dbtables::TBDEDataSet(AOwner) { }
	#pragma option pop
	#pragma option push -w-inl
	/* TBDEDataSet.Destroy */ inline __fastcall virtual ~TCustomBDEItems(void) { }
	#pragma option pop
	
};


class DELPHICLASS TBDEItems;
class PASCALIMPLEMENTATION TBDEItems : public TCustomBDEItems 
{
	typedef TCustomBDEItems inherited;
	
__published:
	__property ItemType  = {default=0};
public:
	#pragma option push -w-inl
	/* TBDEDataSet.Create */ inline __fastcall virtual TBDEItems(Classes::TComponent* AOwner) : TCustomBDEItems(AOwner) { }
	#pragma option pop
	#pragma option push -w-inl
	/* TBDEDataSet.Destroy */ inline __fastcall virtual ~TBDEItems(void) { }
	#pragma option pop
	
};


class DELPHICLASS TDBListDataSet;
class PASCALIMPLEMENTATION TDBListDataSet : public Dbtables::TDBDataSet 
{
	typedef Dbtables::TDBDataSet inherited;
	
protected:
	virtual int __fastcall GetRecordCount(void);
	
public:
	virtual bool __fastcall Locate(const AnsiString KeyFields, const Variant &KeyValues, Db::TLocateOptions Options);
public:
	#pragma option push -w-inl
	/* TDBDataSet.Create */ inline __fastcall virtual TDBListDataSet(Classes::TComponent* AOwner) : Dbtables::TDBDataSet(AOwner) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TBDEDataSet.Destroy */ inline __fastcall virtual ~TDBListDataSet(void) { }
	#pragma option pop
	
};


#pragma option push -b-
enum TDBItemType { dtTables, dtStoredProcs, dtFiles, dtFunctions };
#pragma option pop

class DELPHICLASS TCustomDatabaseItems;
class PASCALIMPLEMENTATION TCustomDatabaseItems : public TDBListDataSet 
{
	typedef TDBListDataSet inherited;
	
private:
	bool FExtended;
	bool FSystemItems;
	AnsiString FFileMask;
	TDBItemType FItemType;
	void __fastcall SetFileMask(const AnsiString Value);
	void __fastcall SetExtendedInfo(bool Value);
	void __fastcall SetSystemItems(bool Value);
	void __fastcall SetItemType(TDBItemType Value);
	
protected:
	virtual Bde::hDBICur __fastcall CreateHandle(void);
	AnsiString __fastcall GetItemName();
	__property TDBItemType ItemType = {read=FItemType, write=SetItemType, default=0};
	__property bool ExtendedInfo = {read=FExtended, write=SetExtendedInfo, default=0};
	__property AnsiString FileMask = {read=FFileMask, write=SetFileMask};
	__property bool SystemItems = {read=FSystemItems, write=SetSystemItems, default=0};
	
public:
	__property AnsiString ItemName = {read=GetItemName};
public:
	#pragma option push -w-inl
	/* TDBDataSet.Create */ inline __fastcall virtual TCustomDatabaseItems(Classes::TComponent* AOwner) : TDBListDataSet(AOwner) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TBDEDataSet.Destroy */ inline __fastcall virtual ~TCustomDatabaseItems(void) { }
	#pragma option pop
	
};


class DELPHICLASS TDatabaseItems;
class PASCALIMPLEMENTATION TDatabaseItems : public TCustomDatabaseItems 
{
	typedef TCustomDatabaseItems inherited;
	
__published:
	__property ItemType  = {default=0};
	__property ExtendedInfo  = {default=0};
	__property FileMask ;
	__property SystemItems  = {default=0};
public:
	#pragma option push -w-inl
	/* TDBDataSet.Create */ inline __fastcall virtual TDatabaseItems(Classes::TComponent* AOwner) : TCustomDatabaseItems(AOwner) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TBDEDataSet.Destroy */ inline __fastcall virtual ~TDatabaseItems(void) { }
	#pragma option pop
	
};


#pragma option push -b-
enum TTabItemType { dtFields, dtIndices, dtValChecks, dtRefInt, dtSecurity, dtFamily };
#pragma option pop

class DELPHICLASS TCustomTableItems;
class PASCALIMPLEMENTATION TCustomTableItems : public TDBListDataSet 
{
	typedef TDBListDataSet inherited;
	
private:
	AnsiString FTableName;
	TTabItemType FItemType;
	bool FPhysTypes;
	void __fastcall SetTableName(const AnsiString Value);
	void __fastcall SetItemType(TTabItemType Value);
	void __fastcall SetPhysTypes(bool Value);
	
protected:
	virtual Bde::hDBICur __fastcall CreateHandle(void);
	__property TTabItemType ItemType = {read=FItemType, write=SetItemType, default=0};
	__property bool PhysTypes = {read=FPhysTypes, write=SetPhysTypes, default=0};
	
__published:
	__property AnsiString TableName = {read=FTableName, write=SetTableName};
public:
	#pragma option push -w-inl
	/* TDBDataSet.Create */ inline __fastcall virtual TCustomTableItems(Classes::TComponent* AOwner) : TDBListDataSet(AOwner) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TBDEDataSet.Destroy */ inline __fastcall virtual ~TCustomTableItems(void) { }
	#pragma option pop
	
};


class DELPHICLASS TTableItems;
class PASCALIMPLEMENTATION TTableItems : public TCustomTableItems 
{
	typedef TCustomTableItems inherited;
	
__published:
	__property ItemType  = {default=0};
	__property PhysTypes  = {default=0};
public:
	#pragma option push -w-inl
	/* TDBDataSet.Create */ inline __fastcall virtual TTableItems(Classes::TComponent* AOwner) : TCustomTableItems(AOwner) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TBDEDataSet.Destroy */ inline __fastcall virtual ~TTableItems(void) { }
	#pragma option pop
	
};


class DELPHICLASS TDatabaseDesc;
class PASCALIMPLEMENTATION TDatabaseDesc : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	#pragma pack(push, 1)
	Bde::DBDesc FDescription;
	#pragma pack(pop)
	
	
public:
	__fastcall TDatabaseDesc(const AnsiString DatabaseName);
	__property Bde::DBDesc Description = {read=FDescription};
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TDatabaseDesc(void) { }
	#pragma option pop
	
};


class DELPHICLASS TDriverDesc;
class PASCALIMPLEMENTATION TDriverDesc : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	#pragma pack(push, 1)
	Bde::DRVType FDescription;
	#pragma pack(pop)
	
	
public:
	__fastcall TDriverDesc(const AnsiString DriverType);
	__property Bde::DRVType Description = {read=FDescription};
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TDriverDesc(void) { }
	#pragma option pop
	
};


//-- var, const, procedure ---------------------------------------------------

}	/* namespace Dblists */
using namespace Dblists;
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// DBLists
