// Borland C++ Builder
// Copyright (c) 1995, 2002 by Borland Software Corporation
// All rights reserved

// (DO NOT EDIT: machine generated header) 'RXSlider.pas' rev: 6.00

#ifndef RXSliderHPP
#define RXSliderHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <Menus.hpp>	// Pascal unit
#include <Messages.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <ExtCtrls.hpp>	// Pascal unit
#include <Controls.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Rxslider
{
//-- type declarations -------------------------------------------------------
typedef Shortint TNumThumbStates;

#pragma option push -b-
enum TSliderOrientation { soHorizontal, soVertical };
#pragma option pop

#pragma option push -b-
enum TSliderOption { soShowFocus, soShowPoints, soSmooth, soRulerOpaque, soThumbOpaque };
#pragma option pop

typedef Set<TSliderOption, soShowFocus, soThumbOpaque>  TSliderOptions;

#pragma option push -b-
enum TSliderImage { siHThumb, siHRuler, siVThumb, siVRuler };
#pragma option pop

typedef Set<TSliderImage, siHThumb, siVRuler>  TSliderImages;

typedef Graphics::TBitmap* TSliderImageArray[4];

#pragma option push -b-
enum TJumpMode { jmNone, jmHome, jmEnd, jmNext, jmPrior };
#pragma option pop

class DELPHICLASS TRxCustomSlider;
class PASCALIMPLEMENTATION TRxCustomSlider : public Controls::TCustomControl 
{
	typedef Controls::TCustomControl inherited;
	
private:
	TSliderImages FUserImages;
	Graphics::TBitmap* FImages[4];
	int FEdgeSize;
	Graphics::TBitmap* FRuler;
	bool FPaintBuffered;
	#pragma pack(push, 1)
	Types::TPoint FRulerOrg;
	#pragma pack(pop)
	
	#pragma pack(push, 1)
	Types::TRect FThumbRect;
	#pragma pack(pop)
	
	bool FThumbDown;
	TNumThumbStates FNumThumbStates;
	#pragma pack(push, 1)
	Types::TRect FPointsRect;
	#pragma pack(pop)
	
	TSliderOrientation FOrientation;
	TSliderOptions FOptions;
	Controls::TBevelCut FBevelStyle;
	int FBevelWidth;
	int FMinValue;
	int FMaxValue;
	int FIncrement;
	int FValue;
	int FHit;
	bool FFocused;
	bool FSliding;
	bool FTracking;
	bool FTimerActive;
	#pragma pack(push, 1)
	Types::TPoint FMousePos;
	#pragma pack(pop)
	
	TJumpMode FStartJump;
	bool FReadOnly;
	Classes::TNotifyEvent FOnChange;
	Classes::TNotifyEvent FOnChanged;
	Classes::TNotifyEvent FOnDrawPoints;
	Graphics::TBitmap* __fastcall GetImage(int Index);
	void __fastcall SetImage(int Index, Graphics::TBitmap* Value);
	void __fastcall SliderImageChanged(System::TObject* Sender);
	void __fastcall SetEdgeSize(int Value);
	TNumThumbStates __fastcall GetNumThumbStates(void);
	void __fastcall SetNumThumbStates(TNumThumbStates Value);
	void __fastcall SetBevelStyle(Controls::TBevelCut Value);
	void __fastcall SetOrientation(TSliderOrientation Value);
	void __fastcall SetOptions(TSliderOptions Value);
	void __fastcall SetMinValue(int Value);
	void __fastcall SetMaxValue(int Value);
	void __fastcall SetIncrement(int Value);
	void __fastcall SetReadOnly(bool Value);
	int __fastcall GetThumbOffset(void);
	void __fastcall SetThumbOffset(int Value);
	void __fastcall SetValue(int Value);
	void __fastcall ThumbJump(TJumpMode Jump);
	Types::TPoint __fastcall GetThumbPosition(int &Offset);
	TJumpMode __fastcall JumpTo(int X, int Y);
	void __fastcall InvalidateThumb(void);
	void __fastcall StopTracking(void);
	void __fastcall TimerTrack(void);
	bool __fastcall StoreImage(int Index);
	void __fastcall CreateElements(void);
	void __fastcall BuildRuler(const Types::TRect &R);
	void __fastcall AdjustElements(void);
	void __fastcall ReadUserImages(Classes::TStream* Stream);
	void __fastcall WriteUserImages(Classes::TStream* Stream);
	void __fastcall InternalDrawPoints(Graphics::TCanvas* ACanvas, int PointsStep, int PointsHeight, int ExtremePointsHeight);
	void __fastcall DrawThumb(Graphics::TCanvas* Canvas, const Types::TPoint &Origin, bool Highlight);
	int __fastcall GetValueByOffset(int Offset);
	int __fastcall GetOffsetByValue(int Value);
	int __fastcall GetRulerLength(void);
	HIDESBASE MESSAGE void __fastcall CMEnabledChanged(Messages::TMessage &Message);
	HIDESBASE MESSAGE void __fastcall CMFocusChanged(Controls::TCMFocusChanged &Message);
	MESSAGE void __fastcall WMGetDlgCode(Messages::TWMNoParams &Msg);
	HIDESBASE MESSAGE void __fastcall WMPaint(Messages::TWMPaint &Message);
	HIDESBASE MESSAGE void __fastcall WMSetCursor(Messages::TWMSetCursor &Message);
	HIDESBASE MESSAGE void __fastcall WMSize(Messages::TWMSize &Message);
	MESSAGE void __fastcall WMTimer(Messages::TMessage &Message);
	
protected:
	virtual void __fastcall AlignControls(Controls::TControl* AControl, Types::TRect &Rect);
	virtual void __fastcall DefineProperties(Classes::TFiler* Filer);
	DYNAMIC void __fastcall KeyDown(Word &Key, Classes::TShiftState Shift);
	virtual void __fastcall Loaded(void);
	DYNAMIC void __fastcall MouseDown(Controls::TMouseButton Button, Classes::TShiftState Shift, int X, int Y);
	DYNAMIC void __fastcall MouseMove(Classes::TShiftState Shift, int X, int Y);
	DYNAMIC void __fastcall MouseUp(Controls::TMouseButton Button, Classes::TShiftState Shift, int X, int Y);
	virtual void __fastcall Paint(void);
	virtual bool __fastcall CanModify(void);
	virtual Types::TRect __fastcall GetSliderRect();
	virtual int __fastcall GetSliderValue(void);
	DYNAMIC void __fastcall Change(void);
	HIDESBASEDYNAMIC void __fastcall Changed(void);
	virtual void __fastcall Sized(void);
	virtual void __fastcall RangeChanged(void);
	void __fastcall SetRange(int Min, int Max);
	virtual void __fastcall ThumbMouseDown(Controls::TMouseButton Button, Classes::TShiftState Shift, int X, int Y);
	virtual void __fastcall ThumbMouseMove(Classes::TShiftState Shift, int X, int Y);
	virtual void __fastcall ThumbMouseUp(Controls::TMouseButton Button, Classes::TShiftState Shift, int X, int Y);
	__property int ThumbOffset = {read=GetThumbOffset, write=SetThumbOffset, nodefault};
	__property Types::TRect SliderRect = {read=GetSliderRect};
	__property Controls::TBevelCut BevelStyle = {read=FBevelStyle, write=SetBevelStyle, default=0};
	__property Graphics::TBitmap* ImageHThumb = {read=GetImage, write=SetImage, stored=StoreImage, index=0};
	__property Graphics::TBitmap* ImageHRuler = {read=GetImage, write=SetImage, stored=StoreImage, index=1};
	__property Graphics::TBitmap* ImageVThumb = {read=GetImage, write=SetImage, stored=StoreImage, index=2};
	__property Graphics::TBitmap* ImageVRuler = {read=GetImage, write=SetImage, stored=StoreImage, index=3};
	__property TNumThumbStates NumThumbStates = {read=GetNumThumbStates, write=SetNumThumbStates, default=2};
	__property TSliderOrientation Orientation = {read=FOrientation, write=SetOrientation, default=0};
	__property int EdgeSize = {read=FEdgeSize, write=SetEdgeSize, default=2};
	__property TSliderOptions Options = {read=FOptions, write=SetOptions, default=7};
	__property bool ReadOnly = {read=FReadOnly, write=SetReadOnly, default=0};
	__property Classes::TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
	__property Classes::TNotifyEvent OnChanged = {read=FOnChanged, write=FOnChanged};
	__property Classes::TNotifyEvent OnDrawPoints = {read=FOnDrawPoints, write=FOnDrawPoints};
	
public:
	__fastcall virtual TRxCustomSlider(Classes::TComponent* AOwner);
	__fastcall virtual ~TRxCustomSlider(void);
	virtual void __fastcall DefaultDrawPoints(int PointsStep, int PointsHeight, int ExtremePointsHeight);
	__property Canvas ;
	__property int Increment = {read=FIncrement, write=SetIncrement, default=10};
	__property int MinValue = {read=FMinValue, write=SetMinValue, default=0};
	__property int MaxValue = {read=FMaxValue, write=SetMaxValue, default=100};
	__property int Value = {read=FValue, write=SetValue, default=0};
public:
	#pragma option push -w-inl
	/* TWinControl.CreateParented */ inline __fastcall TRxCustomSlider(HWND ParentWindow) : Controls::TCustomControl(ParentWindow) { }
	#pragma option pop
	
};


class DELPHICLASS TRxSlider;
class PASCALIMPLEMENTATION TRxSlider : public TRxCustomSlider 
{
	typedef TRxCustomSlider inherited;
	
__published:
	__property Align  = {default=0};
	__property BevelStyle  = {default=0};
	__property Color  = {default=-2147483643};
	__property Cursor  = {default=0};
	__property DragMode  = {default=0};
	__property DragCursor  = {default=-12};
	__property Enabled  = {default=1};
	__property ImageHThumb ;
	__property ImageHRuler ;
	__property ImageVThumb ;
	__property ImageVRuler ;
	__property Increment  = {default=10};
	__property MinValue  = {default=0};
	__property MaxValue  = {default=100};
	__property NumThumbStates  = {default=2};
	__property Orientation  = {default=0};
	__property EdgeSize  = {default=2};
	__property Options  = {default=7};
	__property ParentColor  = {default=1};
	__property ParentShowHint  = {default=1};
	__property PopupMenu ;
	__property ShowHint ;
	__property TabOrder  = {default=-1};
	__property TabStop  = {default=1};
	__property Value  = {default=0};
	__property Visible  = {default=1};
	__property Anchors  = {default=3};
	__property Constraints ;
	__property DragKind  = {default=0};
	__property OnChange ;
	__property OnChanged ;
	__property OnDrawPoints ;
	__property OnClick ;
	__property OnDblClick ;
	__property OnEnter ;
	__property OnExit ;
	__property OnMouseMove ;
	__property OnMouseDown ;
	__property OnMouseUp ;
	__property OnKeyDown ;
	__property OnKeyUp ;
	__property OnKeyPress ;
	__property OnDragOver ;
	__property OnDragDrop ;
	__property OnEndDrag ;
	__property OnStartDrag ;
	__property OnContextPopup ;
	__property OnMouseWheelDown ;
	__property OnMouseWheelUp ;
	__property OnEndDock ;
	__property OnStartDock ;
public:
	#pragma option push -w-inl
	/* TRxCustomSlider.Create */ inline __fastcall virtual TRxSlider(Classes::TComponent* AOwner) : TRxCustomSlider(AOwner) { }
	#pragma option pop
	#pragma option push -w-inl
	/* TRxCustomSlider.Destroy */ inline __fastcall virtual ~TRxSlider(void) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TWinControl.CreateParented */ inline __fastcall TRxSlider(HWND ParentWindow) : TRxCustomSlider(ParentWindow) { }
	#pragma option pop
	
};


class DELPHICLASS TRxCustomTrackBar;
class DELPHICLASS TRxSliderImages;
class PASCALIMPLEMENTATION TRxSliderImages : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	TRxCustomSlider* FSlider;
	TNumThumbStates __fastcall GetNumThumbStates(void);
	void __fastcall SetNumThumbStates(TNumThumbStates Value);
	int __fastcall GetEdgeSize(void);
	void __fastcall SetEdgeSize(int Value);
	Graphics::TBitmap* __fastcall GetImage(int Index);
	void __fastcall SetImage(int Index, Graphics::TBitmap* Value);
	bool __fastcall StoreImage(int Index);
	
__published:
	__property Graphics::TBitmap* HorzThumb = {read=GetImage, write=SetImage, stored=StoreImage, index=0};
	__property Graphics::TBitmap* HorzRuler = {read=GetImage, write=SetImage, stored=StoreImage, index=1};
	__property Graphics::TBitmap* VertThumb = {read=GetImage, write=SetImage, stored=StoreImage, index=2};
	__property Graphics::TBitmap* VertRuler = {read=GetImage, write=SetImage, stored=StoreImage, index=3};
	__property TNumThumbStates NumThumbStates = {read=GetNumThumbStates, write=SetNumThumbStates, default=2};
	__property int EdgeSize = {read=GetEdgeSize, write=SetEdgeSize, default=2};
public:
	#pragma option push -w-inl
	/* TPersistent.Destroy */ inline __fastcall virtual ~TRxSliderImages(void) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Create */ inline __fastcall TRxSliderImages(void) : Classes::TPersistent() { }
	#pragma option pop
	
};


class PASCALIMPLEMENTATION TRxCustomTrackBar : public TRxCustomSlider 
{
	typedef TRxCustomSlider inherited;
	
private:
	TRxSliderImages* FImages;
	
protected:
	__property TRxSliderImages* Images = {read=FImages, write=FImages};
	
public:
	__fastcall virtual TRxCustomTrackBar(Classes::TComponent* AOwner);
	__fastcall virtual ~TRxCustomTrackBar(void);
public:
	#pragma option push -w-inl
	/* TWinControl.CreateParented */ inline __fastcall TRxCustomTrackBar(HWND ParentWindow) : TRxCustomSlider(ParentWindow) { }
	#pragma option pop
	
};


//-- var, const, procedure ---------------------------------------------------

}	/* namespace Rxslider */
using namespace Rxslider;
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// RXSlider
